"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function NamespaceAddonImports( /* babel: any */) {
    // const { types: t } = babel;
    return {
        name: "namespace-addon-imports",
        visitor: {
            ImportDeclaration(path, state) {
                let { name, cacheKey, appOrAddonName } = state.opts; // grab from babel options
                let source = path.node.source.value;
                if (appOrAddonName === 'host-app') {
                    // console.log('!!! namespace imports');
                    console.log('source', source);
                    // console.log('state', state.opts);
                }
                if (source.startsWith(".") || source.startsWith("/")) {
                    return;
                }
                // only modify the package we are targetting
                if (!source.startsWith(name)) {
                    return;
                }
                let scopedSource = `${name}/${cacheKey}${source.slice(name.length)}`;
                console.log('******* scopedSource', scopedSource);
                path.node.source.value = scopedSource;
            }
        }
    };
}
exports.default = NamespaceAddonImports;
//# sourceMappingURL=namespace-addon-imports-babel.js.map